Attribute VB_Name = "mSample"

Option Explicit

' System menu commands
Public Const SC_SIZE = &HF000&
Public Const SC_MOVE = &HF010&
Public Const SC_MINIMIZE = &HF020&
Public Const SC_MAXIMIZE = &HF030&
Public Const SC_NEXTWINDOW = &HF040&
Public Const SC_PREVWINDOW = &HF050&
Public Const SC_CLOSE = &HF060&
Public Const SC_RESTORE = &HF120&

' Custom Colors
Public Const vbMaroon = 128
Public Const vbNavy = 8388608
Public Const vbPurple = 8388736
Public Const vbTeal = 8421376
Public Const vbGray = 8421504
Public Const vbSilver = 12632256
Public Const vbViolet = 9445584
Public Const vbOrange = 42495
Public Const vbGold = 43724
Public Const vbIvory = 15794175
Public Const vbPeach = 12180223
Public Const vbTurquoise = 13749760
Public Const vbTan = 9221330

' File information for SHGetFileInfo
Public Const SHGFI_ICON = &H100
Public Const SHGFI_SMALLICON = &H1        ' Small icon

' Drive types
Private Const DRIVE_UNKNOWN = 0
Private Const DRIVE_ABSENT = 1
Private Const DRIVE_REMOVABLE = 2
Private Const DRIVE_FIXED = 3
Private Const DRIVE_REMOTE = 4
Private Const DRIVE_CDROM = 5
Private Const DRIVE_RAMDISK = 6


' File icon
Public Type TypeIcon
    cbSize As Long
    picType As PictureTypeConstants
    hIcon As Long
End Type

Public Type CLSID
    ID(16) As Byte
End Type

' File info for SHGetFileInfo
Public Type SHFILEINFO
    hIcon As Long
    iIcon As Long
    dwAttributes As Long
    szDisplayName As String * 250
    szTypeName As String * 80
End Type


Public Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" _
                                (ByVal nBufferLength As Long, _
                                 ByVal lpBuffer As String) As Long

Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" _
                                (ByVal nDrive As String) As Long

Public Declare Function SHGetFileInfo Lib "shell32.dll" Alias "SHGetFileInfoA" _
                                (ByVal pszPath As String, _
                                 ByVal dwFileAttributes As Long, _
                                 psfi As SHFILEINFO, _
                                 ByVal cbFileInfo As Long, _
                                 ByVal uFlags As Long) As Long

Public Declare Function OleCreatePictureIndirect Lib "oleaut32.dll" _
                                (pDicDesc As TypeIcon, _
                                 riid As CLSID, _
                                 ByVal fown As Long, _
                                 lpUnk As Object) As Long


' Returns the type of the specified drive
'
' Called from GetDrives
Public Function DriveType(ByVal sDrive As String) As String
      
  On Error Resume Next

  Dim iRet As Long
  Dim sType As String

    ' Get the drive type
    iRet = GetDriveType(sDrive)
    
    ' Set the text according the drive type
    Select Case iRet
        Case DRIVE_ABSENT
            sType = "Drive does not exist"
        Case DRIVE_REMOVABLE
            sType = "Removable Media"
        Case DRIVE_FIXED
            sType = "Fixed Drive"
        Case DRIVE_REMOTE
            sType = "Network Drive"
        Case DRIVE_CDROM
            sType = "CD Rom"
        Case DRIVE_RAMDISK
            sType = "Ram Disk"
        ' Drive type cannot be determined
        Case Else
            sType = "Unknown Drive Type"
    End Select
    
    ' Return the text for the specific drive type
    DriveType = sType
    
End Function

' Returns the small icon associated with the specified drive
'
' Called from GetDrives
Public Function GetDriveIcon(ByVal Filename As String) As IPictureDisp

  On Error Resume Next

  Dim hIcon As Long
  Dim SFI As SHFILEINFO

    ' Get info about the drive into SFI
    Call SHGetFileInfo(Filename, 0, SFI, Len(SFI), SHGFI_ICON Or SHGFI_SMALLICON)
    
    ' Get the handle of the icon
    hIcon = SFI.hIcon
    
    ' Return the icon
    Set GetDriveIcon = IconToPicture(hIcon)

End Function

' Returns the part of the specified string up to the first Null char
'
' Called from GetDrives
Public Function TrimToNull(sBuffer As String) As String

  On Error Resume Next

  Dim iPos As Long

    ' Find the first Null char position in sBuffer
    iPos = InStr(sBuffer, vbNullChar)

    ' If a Null char exists
    If iPos > 0 Then
        ' Return the part of the string up to the Null char
        TrimToNull = Left$(sBuffer, iPos - 1)
        ' If a Null char does not exist
        Else
        ' Return the whole string
        TrimToNull = sBuffer
    End If

End Function






































' Converts an icon handle into an IPictureDisp.
'
' Called from GetDriveIcon
Private Function IconToPicture(ByVal hIcon As Long) As IPictureDisp

  On Error Resume Next

  Dim iRet As Long
  Dim Icon As TypeIcon
  Dim CID As CLSID
  Dim IUN As IUnknown

    ' Set Icon
    With Icon
        .cbSize = Len(Icon)
        .picType = vbPicTypeIcon
        .hIcon = hIcon
    End With
    
    ' Set CID
    With CID
        .ID(8) = &HC0
        .ID(15) = &H46
    End With
    
    ' Create the picture
    iRet = OleCreatePictureIndirect(Icon, CID, 1, IUN)
    
    ' If no error
    If iRet = 0 Then
        ' Return the icon
        Set IconToPicture = IUN
    End If

End Function


